<img src="media/logo/ic_app.png" height="100px" />

# Hash Checker

<a href="https://github.com/hash-checker/hash-checker/releases">
  <img src="media/banners/bn_github.png" height="75px" />
</a>
<a href="https://play.google.com/store/apps/details?id=com.smlnskgmail.jaman.hashchecker">
  <img src="media/banners/bn_google_play.png" height="75px" />
</a>
<a href="https://apt.izzysoft.de/fdroid/index/apk/com.smlnskgmail.jaman.hashchecker">
  <img src="media/banners/bn_izzy_on_droid.png" height="75px" />
</a>
<a href="https://www.androidfilehost.com/?w=files&flid=316843">
  <img src="media/banners/bn_android_file_host.png" height="75px" />
</a>

[![GitHubActions](https://github.com/hash-checker/hash-checker/workflows/Build/badge.svg)](https://github.com/hash-checker/hash-checker/actions?query=workflow%3ABuild)
[![Codacy](https://api.codacy.com/project/badge/Grade/51f19c1c57a443bba0713785abe708c3)](https://app.codacy.com/gh/hash-checker/hash-checker?utm_source=github.com&utm_medium=referral&utm_content=hash-checker/hash-checker&utm_campaign=Badge_Grade)
[![Codecov](https://codecov.io/gh/hash-checker/hash-checker/branch/master/graph/badge.svg)](https://codecov.io/gh/hash-checker/hash-checker)
[![Android Arsenal](https://img.shields.io/badge/Android%20Arsenal-Hash%20Checker-brightgreen.svg?style=flat)](https://android-arsenal.com/details/3/7854)

## About application

Fast and simple application that allows you to generate and compare hashes from files and text.

## Supporting algorithms

| Name | Since version | Status |
| --- | --- | --- |
| [MD5](https://en.wikipedia.org/wiki/MD5) | 1.0.0 | `Supporting` |
| [SHA-1](https://en.wikipedia.org/wiki/SHA-1) | 1.0.0 | `Supporting` |
| [SHA-224](https://en.wikipedia.org/wiki/SHA-2) | 1.4.0 | `Supporting` |
| [SHA-256](https://en.wikipedia.org/wiki/SHA-2) | 1.0.0 | `Supporting` |
| [SHA-384](https://en.wikipedia.org/wiki/SHA-2) | 1.4.0 | `Supporting` |
| [SHA-512](https://en.wikipedia.org/wiki/SHA-2) | 1.0.0 | `Supporting` |
| [CRC-32](https://en.wikipedia.org/wiki/Cyclic_redundancy_check) | 2.9.0 | `Supporting` |
| [SHA3-224](https://en.wikipedia.org/wiki/SHA-3) | 3.6.5 | `Supporting` |
| [SHA3-256](https://en.wikipedia.org/wiki/SHA-3) | 3.6.5 | `Supporting` |
| [SHA3-384](https://en.wikipedia.org/wiki/SHA-3) | 3.6.5 | `Supporting` |
| [SHA3-512](https://en.wikipedia.org/wiki/SHA-3) | 3.6.5 | `Supporting` |

## Supporting languages

You can help with translation on [OneSky](https://osbvnmv.oneskyapp.com/collaboration/project?id=353871).

__Languages in app__

| Language | Since version | Status |
| --- | --- | --- |
| English | 1.0.0 | `Translated` |
| Español | 2.9.9 | [Help wanted](https://github.com/hash-checker/hash-checker/issues/9) |
| Deutsch | 2.9.6 | `Translated` |
| Français | 2.9.9 | [Help wanted](https://github.com/hash-checker/hash-checker/issues/11) |
| Italiano | 2.9.9 | [Help wanted](https://github.com/hash-checker/hash-checker/issues/12) |
| Magyar | 2.9.9 | [Help wanted](https://github.com/hash-checker/hash-checker/issues/13) |
| Nederlands | 2.9.9 | [Help wanted](https://github.com/hash-checker/hash-checker/issues/14) |
| Svenska | 2.9.9 | [Help wanted](https://github.com/hash-checker/hash-checker/issues/15) |
| Ελληνικά | 2.9.9 | [Help wanted](https://github.com/hash-checker/hash-checker/issues/16) |
| Русский | 2.9.6 | `Translated` |
| Polski | 2.9.9 | [Help wanted](https://github.com/hash-checker/hash-checker/issues/20) |
| Português (Brasil) | 3.7.0 | `Translated` |
| 简体中文 | 2.9.9 | `Translated` |
| 한국어 | 2.9.9 | [Help wanted](https://github.com/hash-checker/hash-checker/issues/19) |
| עברית | 2.9.9 | [Help wanted](https://github.com/hash-checker/hash-checker/issues/17) |
| فارسی | 2.9.9 | `Translated` |
| 日本語 | 3.6.3 | `Translated` |
| Tiếng Việt | 3.6.5 | `Translated` |

__Not translated__

| Language | Since version | Status |
| --- | --- | --- |
| Bahasa Indonesia | - | [Help wanted](https://github.com/hash-checker/hash-checker/issues/36) |
| हिंदी | - | [Help wanted](https://github.com/hash-checker/hash-checker/issues/37) |
| Українська мова | - | [Help wanted](https://github.com/hash-checker/hash-checker/issues/38) |
| norsk | - | [Help wanted](https://github.com/hash-checker/hash-checker/issues/40) |
| čeština | - | [Help wanted](https://github.com/hash-checker/hash-checker/issues/41) |
| suomi | - | [Help wanted](https://github.com/hash-checker/hash-checker/issues/42) |
| Tiếng Việt | - | [Help wanted](https://github.com/hash-checker/hash-checker/issues/43) |
| srpski | - | [Help wanted](https://github.com/hash-checker/hash-checker/issues/44) |
| dansk | - | [Help wanted](https://github.com/hash-checker/hash-checker/issues/45) |

## Screenshots (Light theme)

<br/>
<p align="center">
  <img src="media/screenshots/screenshot_01.png" width="130" />
  <img src="media/screenshots/screenshot_02.png" width="130" />
  <img src="media/screenshots/screenshot_03.png" width="130" />
  <img src="media/screenshots/screenshot_04.png" width="130" />
  <img src="media/screenshots/screenshot_05.png" width="130" />
</p>

## Screenshots (Dark theme)

<br/>
<p align="center">
  <img src="media/screenshots/screenshot_06.png" width="130" />
  <img src="media/screenshots/screenshot_07.png" width="130" />
  <img src="media/screenshots/screenshot_08.png" width="130" />
  <img src="media/screenshots/screenshot_09.png" width="130" />
  <img src="media/screenshots/screenshot_10.png" width="130" />
</p>

## How to use

* [H2S Media](https://www.how2shout.com/how-to/how-to-calculate-the-hash-of-a-file-or-create-custom-hash-on-android.html)

## Videos

* [YouTube](https://www.youtube.com/watch?v=Q7Otn971kJk&list=PLOIwDRWd_SDdBz2aiVtMocFunaXaKSPMx)

## Black Duck Open Hub

* [Hash Checker (Android)](https://www.openhub.net/p/hash-checker)

## Privacy Policy

* [Web version](https://hash-checker.github.io/hash-checker-privacy-policy.io/)

## Feedback

If you have any question or feature idea for app, you can open issue on [this page](https://github.com/hash-checker/hash-checker/issues) or contact me by email jaman.smlnsk@gmail.com.

## How to contribute

Start with [How to build a project](https://github.com/hash-checker/hash-checker/wiki/How-to-build-a-project).

Before commit, read [Commit Convention](https://github.com/fartem/repository-rules/blob/master/commit-convention/COMMIT_CONVENTION.md). Make sure your build is green before you contribute your pull request. Then:

```shell
$ ./gradlew clean
$ ./gradlew build
$ ./gradlew -Pandroid.testInstrumentationRunnerArguments.class=com.smlnskgmail.jaman.hashchecker.AndroidTestSuite connectedCheck
```

If you don't see any error messages, submit your pull request.

## Contributors

* [@fartem](https://github.com/fartem) as Artem Fomchenkov
* [@Marwa-Eltayeb](https://github.com/Marwa-Eltayeb) as Marwa Said
* [@vaqueraexe](https://github.com/vaqueraexe) as Sergio Amaya
* [@firaja](https://github.com/firaja) as David Bertoldi
* [@fu7mu4](https://github.com/fu7mu4) as fu7mu4
* [@AmrDeveloper](https://github.com/AmrDeveloper) as Amr Hesham
* [@vipozdn](https://github.com/vipozdn) as Victor
* [@itamarc](https://github.com/itamarc) as Itamar Carvalho

## Special thanks

* [@IzzySoft](https://github.com/IzzySoft) as Izzy for uploading the app to [IzzySoft Apt Repositories](https://apt.izzysoft.de)
* [@lexterror](https://github.com/lexterror) as mrrmx for useful feature requests
